<template>
  <q-item
    clickable
    exact
    :to="isExternalLink ? '' : link"
    @click.native="isExternalLink ? openExternalLink() : false"
  >
    <q-item-section
      v-if="icon"
      avatar
    >
      <q-icon :name="icon" />
    </q-item-section>

    <q-item-section>
      <q-item-label>{{ title }}</q-item-label>
      <q-item-label caption>
        {{ caption }}
      </q-item-label>
    </q-item-section>
  </q-item>
</template>

<script lang="ts">
import Vue from 'vue';
import { openURL } from 'quasar'

export default Vue.extend({
  computed: {
    isExternalLink() {
      return this.link.startsWith('http');
    },
  },
  methods: {
    openExternalLink() {
      openURL(this.$props.link);
    },
  },
  name: 'EssentialLink',
  props: {
    title: {
      type: String,
      required: true,
    },

    caption: {
      type: String,
      default: '',
    },

    link: {
      type: String,
      default: '#',
    },

    icon: {
      type: String,
      default: '',
    },
  },
});
</script>
